diff --git a/usr/src/uts/common/io/cxgbe/t4nex/t4_nexus.c b/usr/src/uts/common/io/cxgbe/t4nex/t4_nexus.c
index ad2fda1caa..83b4c8f94f 100644
--- a/usr/src/uts/common/io/cxgbe/t4nex/t4_nexus.c
+++ b/usr/src/uts/common/io/cxgbe/t4nex/t4_nexus.c
@@ -400,140 +864,44 @@ t4_devo_attach(dev_info_t *dip, ddi_attach_cmd_t cmd)
 		mutex_init(&pi->lock, NULL, MUTEX_DRIVER, NULL);
 		pi->mtu = ETHERMTU;
 
-		if (t4_port_is_10xg(pi)) {
-			nxg++;
-			pi->tmr_idx = prp->tmr_idx_10g;
-			pi->pktc_idx = prp->pktc_idx_10g;
-		} else {
-			n1g++;
-			pi->tmr_idx = prp->tmr_idx_1g;
-			pi->pktc_idx = prp->pktc_idx_1g;
-		}
+		pi->tmr_idx = prp->ethq_tmr_idx;
+		pi->pktc_idx = prp->ethq_pktc_idx;
 		pi->dbq_timer_idx = prp->dbq_timer_idx;
 
 		pi->xact_addr_filt = -1;
 	}
 
-	(void) remove_extra_props(sc, nxg, n1g);
-
-	rc = cfg_itype_and_nqueues(sc, nxg, n1g, &iaq);
-	if (rc != 0)
+	if ((rc = t4_cfg_intrs_queues(sc)) != 0) {
 		goto done; /* error message displayed already */
-
-	sc->intr_type = iaq.intr_type;
-	sc->intr_count = iaq.nirq;
-
-	if (sc->props.multi_rings && (sc->intr_type != DDI_INTR_TYPE_MSIX)) {
-		sc->props.multi_rings = 0;
-		cxgb_printf(dip, CE_WARN,
-		    "Multiple rings disabled as interrupt type is not MSI-X");
 	}
 
-	if (sc->props.multi_rings && iaq.intr_fwd) {
-		sc->props.multi_rings = 0;
-		cxgb_printf(dip, CE_WARN,
-		    "Multiple rings disabled as interrupts are forwarded");
-	}
-
-	if (!sc->props.multi_rings) {
-		iaq.ntxq10g = 1;
-		iaq.ntxq1g = 1;
-	}
-	s = &sc->sge;
-	s->nrxq = nxg * iaq.nrxq10g + n1g * iaq.nrxq1g;
-	s->ntxq = nxg * iaq.ntxq10g + n1g * iaq.ntxq1g;
-	s->neq = s->ntxq + s->nrxq;	/* the fl in an rxq is an eq */
-	s->niq = s->nrxq + 1;		/* 1 extra for firmware event queue */
-	if (iaq.intr_fwd != 0)
-		sc->flags |= TAF_INTR_FWD;
-	s->rxq = kmem_zalloc(s->nrxq * sizeof (struct sge_rxq), KM_SLEEP);
-	s->txq = kmem_zalloc(s->ntxq * sizeof (struct sge_txq), KM_SLEEP);
-	s->iqmap =
-	    kmem_zalloc(s->iqmap_sz * sizeof (struct sge_iq *), KM_SLEEP);
-	s->eqmap =
-	    kmem_zalloc(s->eqmap_sz * sizeof (struct sge_eq *), KM_SLEEP);
+	const struct t4_intrs_queues *iaq = &sc->intr_queue_cfg;
+	struct sge_info *sge = &sc->sge;
+	sge->rxq =
+	    kmem_zalloc(sge->rxq_count * sizeof (struct sge_rxq), KM_SLEEP);
+	sge->txq =
+	    kmem_zalloc(sge->txq_count * sizeof (struct sge_txq), KM_SLEEP);
+	sge->iqmap =
+	    kmem_zalloc(sge->iqmap_sz * sizeof (struct sge_iq *), KM_SLEEP);
+	sge->eqmap =
+	    kmem_zalloc(sge->eqmap_sz * sizeof (struct sge_eq *), KM_SLEEP);
 
 	sc->intr_handle =
-	    kmem_zalloc(sc->intr_count * sizeof (ddi_intr_handle_t), KM_SLEEP);
+	    kmem_zalloc(iaq->intr_count * sizeof (ddi_intr_handle_t),
+	    KM_SLEEP);
 
 	/*
-	 * Second pass over the ports.  This time we know the number of rx and
-	 * tx queues that each port should get.
+	 * Enable hw checksumming and LSO for all ports by default.
+	 * They can be disabled using ndd (hw_csum and hw_lso).
 	 */
-	rqidx = tqidx = 0;
 	for_each_port(sc, i) {
-		struct port_info *pi = sc->port[i];
-
-		if (pi == NULL)
-			continue;
-
-		t4_mc_cb_init(pi);
-		pi->first_rxq = rqidx;
-		pi->nrxq = (t4_port_is_10xg(pi)) ? iaq.nrxq10g : iaq.nrxq1g;
-		pi->first_txq = tqidx;
-		pi->ntxq = (t4_port_is_10xg(pi)) ? iaq.ntxq10g : iaq.ntxq1g;
-
-		rqidx += pi->nrxq;
-		tqidx += pi->ntxq;
-
-		/*
-		 * Enable hw checksumming and LSO for all ports by default.
-		 * They can be disabled using ndd (hw_csum and hw_lso).
-		 */
-		pi->features |= (CXGBE_HW_CSUM | CXGBE_HW_LSO);
+		sc->port[i]->features |= (CXGBE_HW_CSUM | CXGBE_HW_LSO);
 	}
 
-	/*
-	 * Setup Interrupts.
-	 */
-
-	i = 0;
-	rc = ddi_intr_alloc(dip, sc->intr_handle, sc->intr_type, 0,
-	    sc->intr_count, &i, DDI_INTR_ALLOC_STRICT);
-	if (rc != DDI_SUCCESS) {
-		cxgb_printf(dip, CE_WARN,
-		    "failed to allocate %d interrupt(s) of type %d: %d, %d",
-		    sc->intr_count, sc->intr_type, rc, i);
+	/* Setup Interrupts. */
+	if ((rc = t4_setup_intrs(sc)) != DDI_SUCCESS) {
 		goto done;
 	}
-	ASSERT(sc->intr_count == i); /* allocation was STRICT */
-	(void) ddi_intr_get_cap(sc->intr_handle[0], &sc->intr_cap);
-	(void) ddi_intr_get_pri(sc->intr_handle[0], &sc->intr_pri);
-	if (sc->intr_count == 1) {
-		ASSERT(sc->flags & TAF_INTR_FWD);
-		(void) ddi_intr_add_handler(sc->intr_handle[0], t4_intr_all, sc,
-		    &s->fwq);
-	} else {
-		/* Multiple interrupts.  The first one is always error intr */
-		(void) ddi_intr_add_handler(sc->intr_handle[0], t4_intr_err, sc,
-		    NULL);
-		irq++;
-
-		/* The second one is always the firmware event queue */
-		(void) ddi_intr_add_handler(sc->intr_handle[1], t4_intr, sc,
-		    &s->fwq);
-		irq++;
-		/*
-		 * Note that if TAF_INTR_FWD is set then either the NIC rx
-		 * queues or (exclusive or) the TOE rx queueus will be taking
-		 * direct interrupts.
-		 *
-		 * There is no need to check for is_offload(sc) as nofldrxq
-		 * will be 0 if offload is disabled.
-		 */
-		for_each_port(sc, i) {
-			struct port_info *pi = sc->port[i];
-			struct sge_rxq *rxq;
-			rxq = &s->rxq[pi->first_rxq];
-			for (q = 0; q < pi->nrxq; q++, rxq++) {
-				(void) ddi_intr_add_handler(
-				    sc->intr_handle[irq], t4_intr, sc,
-				    &rxq->iq);
-				irq++;
-			}
-		}
-
-	}
 	sc->flags |= TAF_INTR_ALLOC;
 
 	if ((rc = ksensor_create_scalar_pcidev(dip, SENSOR_KIND_TEMPERATURE,
@@ -561,17 +929,31 @@ t4_devo_attach(dev_info_t *dip, ddi_attach_cmd_t cmd)
 	}
 	ddi_ufm_update(sc->ufm_hdl);
 
-	if ((rc = t4_alloc_fwq(sc)) != 0) {
+	if ((rc = t4_alloc_evt_iqs(sc)) != 0) {
 		cxgb_printf(dip, CE_WARN, "failed to alloc FWQ: %d", rc);
 		rc = DDI_FAILURE;
 		goto done;
 	}
 
 	if (sc->intr_cap & DDI_INTR_FLAG_BLOCK) {
-		(void) ddi_intr_block_enable(sc->intr_handle, sc->intr_count);
+		rc = ddi_intr_block_enable(sc->intr_handle, iaq->intr_count);
+
+		if (rc != DDI_SUCCESS) {
+			cxgb_printf(dip, CE_WARN, "failed to enable intr "
+			    "block: %d", rc);
+			rc = DDI_FAILURE;
+			goto done;
+		}
 	} else {
-		for (i = 0; i < sc->intr_count; i++)
-			(void) ddi_intr_enable(sc->intr_handle[i]);
+		for (i = 0; i < iaq->intr_count; i++) {
+			rc = ddi_intr_enable(sc->intr_handle[i]);
+			if (rc != DDI_SUCCESS) {
+				cxgb_printf(dip, CE_WARN, "failed to enable "
+				    "intr %d: %d", i, rc);
+				rc = DDI_FAILURE;
+				goto done;
+			}
+		}
 	}
 	t4_intr_enable(sc);
 
@@ -588,14 +970,8 @@ t4_devo_attach(dev_info_t *dip, ddi_attach_cmd_t cmd)
 	 */
 	t4_dump_version_info(sc);
 
-	cxgb_printf(dip, CE_NOTE, "(%d rxq, %d txq total) %d %s.",
-	    rqidx, tqidx, sc->intr_count,
-	    sc->intr_type == DDI_INTR_TYPE_MSIX ? "MSI-X interrupts" :
-	    sc->intr_type == DDI_INTR_TYPE_MSI ? "MSI interrupts" :
-	    "fixed interrupt");
-
-	sc->ksp = setup_kstats(sc);
-	sc->ksp_stat = setup_wc_kstats(sc);
+	sc->ksp = t4_setup_kstats(sc);
+	sc->ksp_stat = t4_setup_wc_kstats(sc);
 	sc->params.drv_memwin = MEMWIN_NIC;
 
 done:
@@ -612,36 +988,37 @@ done:
 static int
 t4_devo_detach(dev_info_t *dip, ddi_detach_cmd_t cmd)
 {
-	int instance, i;
-	struct adapter *sc;
+	int i = 0;
 	struct port_info *pi;
-	struct sge *s;
+	struct sge_info *s;
 
 	if (cmd != DDI_DETACH)
 		return (DDI_FAILURE);
 
-	instance = ddi_get_instance(dip);
-	sc = ddi_get_soft_state(t4_soft_state, instance);
+	const int instance = ddi_get_instance(dip);
+	struct adapter *sc = ddi_get_soft_state(t4_soft_state, instance);
 	if (sc == NULL)
 		return (DDI_SUCCESS);
 
+	struct t4_intrs_queues *iaq = &sc->intr_queue_cfg;
+
 	if (sc->flags & TAF_INIT_DONE) {
 		t4_intr_disable(sc);
 		for_each_port(sc, i) {
 			pi = sc->port[i];
 			if (pi && pi->flags & TPF_INIT_DONE)
-				(void) t4_port_full_uninit(pi);
+				t4_port_full_uninit(pi);
 		}
 
 		if (sc->intr_cap & DDI_INTR_FLAG_BLOCK) {
 			(void) ddi_intr_block_disable(sc->intr_handle,
-			    sc->intr_count);
+			    iaq->intr_count);
 		} else {
-			for (i = 0; i < sc->intr_count; i++)
+			for (i = 0; i < iaq->intr_count; i++)
 				(void) ddi_intr_disable(sc->intr_handle[i]);
 		}
 
-		(void) t4_free_fwq(sc);
+		t4_free_evt_iqs(sc);
 
 		sc->flags &= ~TAF_INIT_DONE;
 	}
@@ -662,9 +1039,9 @@ t4_devo_detach(dev_info_t *dip, ddi_detach_cmd_t cmd)
 
 	s = &sc->sge;
 	if (s->rxq != NULL)
-		kmem_free(s->rxq, s->nrxq * sizeof (struct sge_rxq));
+		kmem_free(s->rxq, s->rxq_count * sizeof (struct sge_rxq));
 	if (s->txq != NULL)
-		kmem_free(s->txq, s->ntxq * sizeof (struct sge_txq));
+		kmem_free(s->txq, s->txq_count * sizeof (struct sge_txq));
 	if (s->iqmap != NULL)
 		kmem_free(s->iqmap, s->iqmap_sz * sizeof (struct sge_iq *));
 	if (s->eqmap != NULL)
@@ -674,21 +1051,39 @@ t4_devo_detach(dev_info_t *dip, ddi_detach_cmd_t cmd)
 		kmem_cache_destroy(s->rxbuf_cache);
 
 	if (sc->flags & TAF_INTR_ALLOC) {
-		for (i = 0; i < sc->intr_count; i++) {
-			(void) ddi_intr_remove_handler(sc->intr_handle[i]);
-			(void) ddi_intr_free(sc->intr_handle[i]);
+		for (int i = 0; i < iaq->intr_count; i++) {
+			int rc = ddi_intr_remove_handler(sc->intr_handle[i]);
+			if (rc != DDI_SUCCESS) {
+				cxgb_printf(sc->dip, CE_WARN, "failed to "
+				    "remove interrupt handler %d for type: %d "
+				    "plan: %d: %d", i, iaq->intr_type,
+				    iaq->intr_plan, rc);
+			}
+
+			rc = ddi_intr_free(sc->intr_handle[i]);
+			if (rc != DDI_SUCCESS) {
+				cxgb_printf(sc->dip, CE_WARN, "failed to free "
+				    "interrupt %d for type: %d plan: %d: %d", i,
+				    iaq->intr_type, iaq->intr_plan, rc);
+
+			}
 		}
 		sc->flags &= ~TAF_INTR_ALLOC;
 	}
 
 	if (sc->intr_handle != NULL) {
 		kmem_free(sc->intr_handle,
-		    sc->intr_count * sizeof (*sc->intr_handle));
+		    iaq->intr_count * sizeof (*sc->intr_handle));
 	}
 
 	for_each_port(sc, i) {
 		pi = sc->port[i];
 		if (pi != NULL) {
+			if (pi->intr_iqs != NULL) {
+				kmem_free(pi->intr_iqs,
+				    sizeof (pi->intr_iqs[0]) *
+				    sc->intr_queue_cfg.intr_per_port);
+			}
 			mutex_destroy(&pi->lock);
 			kmem_free(pi, sizeof (*pi));
 		}
@@ -758,9 +1153,10 @@ t4_bus_ctl(dev_info_t *dip, dev_info_t *rdip, ddi_ctl_enum_t op, void *arg,
 
 	switch (op) {
 	case DDI_CTLOPS_REPORTDEV:
-		pi = ddi_get_parent_data(rdip);
-		pi->instance = ddi_get_instance(dip);
-		pi->child_inst = ddi_get_instance(rdip);
+		if (rdip == NULL)
+			return (DDI_FAILURE);
+		cmn_err(CE_CONT, "?t4nexus: %s%d\n",
+		    ddi_driver_name(rdip), ddi_get_instance(rdip));
 		return (DDI_SUCCESS);
 
 	case DDI_CTLOPS_INITCHILD:
@@ -784,43 +1180,58 @@ t4_bus_ctl(dev_info_t *dip, dev_info_t *rdip, ddi_ctl_enum_t op, void *arg,
 	}
 }
 
+/* From a provided "cxgbe@0" string, parse the device number */
+static bool
+t4_parse_devnum(const char *devname, uint_t *inst_nump)
+{
+	const size_t name_sz = strlen(devname) + 1;
+	char *name_copy = i_ddi_strdup(devname, KM_SLEEP);
+
+	bool res = false;
+	char *nodename, *addrname = NULL;
+	i_ddi_parse_name(name_copy, &nodename, &addrname, NULL);
+	if (addrname == NULL || strcmp(T4_PORT_NAME, nodename) != 0) {
+		goto done;
+	}
+
+	ulong_t num;
+	if (ddi_strtoul(addrname, NULL, 10, &num) != 0 || num > UINT_MAX) {
+		goto done;
+	}
+	*inst_nump = (uint_t)num;
+	res = true;
+
+done:
+	kmem_free(name_copy, name_sz);
+	return (res);
+}
+
 static int
 t4_bus_config(dev_info_t *dip, uint_t flags, ddi_bus_config_op_t op, void *arg,
     dev_info_t **cdipp)
 {
-	int instance, i;
-	struct adapter *sc;
-
-	instance = ddi_get_instance(dip);
-	sc = ddi_get_soft_state(t4_soft_state, instance);
+	struct adapter *sc =
+	    ddi_get_soft_state(t4_soft_state, ddi_get_instance(dip));
 
 	if (op == BUS_CONFIG_ONE) {
-		char *c;
-
-		/*
-		 * arg is something like "cxgb@0" where 0 is the port_id hanging
-		 * off this nexus.
-		 */
+		uint_t dev_num;
 
-		c = arg;
-		while (*(c + 1))
-			c++;
-
-		/* There should be exactly 1 digit after '@' */
-		if (*(c - 1) != '@')
+		if (!t4_parse_devnum((const char *)arg, &dev_num)) {
 			return (NDI_FAILURE);
-
-		i = *c - '0';
-
-		if (add_child_node(sc, i) != 0)
+		}
+		if (t4_add_child_node(sc, dev_num) != 0) {
 			return (NDI_FAILURE);
+		}
 
 		flags |= NDI_ONLINE_ATTACH;
 
 	} else if (op == BUS_CONFIG_ALL || op == BUS_CONFIG_DRIVER) {
+		int i;
+
 		/* Allocate and bind all child device nodes */
-		for_each_port(sc, i)
-		    (void) add_child_node(sc, i);
+		for_each_port(sc, i) {
+			(void) t4_add_child_node(sc, (uint_t)i);
+		}
 		flags |= NDI_ONLINE_ATTACH;
 	}
 
@@ -831,107 +1242,97 @@ static int
 t4_bus_unconfig(dev_info_t *dip, uint_t flags, ddi_bus_config_op_t op,
     void *arg)
 {
-	int instance, i, rc;
-	struct adapter *sc;
-
-	instance = ddi_get_instance(dip);
-	sc = ddi_get_soft_state(t4_soft_state, instance);
+	struct adapter *sc
+	    = ddi_get_soft_state(t4_soft_state, ddi_get_instance(dip));
 
-	if (op == BUS_CONFIG_ONE || op == BUS_UNCONFIG_ALL ||
-	    op == BUS_UNCONFIG_DRIVER)
+	if (op == BUS_UNCONFIG_ONE ||
+	    op == BUS_UNCONFIG_ALL ||
+	    op == BUS_UNCONFIG_DRIVER) {
 		flags |= NDI_UNCONFIG;
+	}
 
-	rc = ndi_busop_bus_unconfig(dip, flags, op, arg);
+	int rc = ndi_busop_bus_unconfig(dip, flags, op, arg);
 	if (rc != 0)
 		return (rc);
 
 	if (op == BUS_UNCONFIG_ONE) {
-		char *c;
-
-		c = arg;
-		while (*(c + 1))
-			c++;
+		uint_t dev_num;
 
-		if (*(c - 1) != '@')
-			return (NDI_SUCCESS);
-
-		i = *c - '0';
-
-		rc = remove_child_node(sc, i);
+		if (!t4_parse_devnum((const char *)arg, &dev_num)) {
+			return (NDI_FAILURE);
+		}
 
+		rc = t4_remove_child_node(sc, dev_num);
 	} else if (op == BUS_UNCONFIG_ALL || op == BUS_UNCONFIG_DRIVER) {
+		uint_t i;
 
-		for_each_port(sc, i)
-		    (void) remove_child_node(sc, i);
+		for_each_port(sc, i) {
+			(void) t4_remove_child_node(sc, i);
+		}
 	}
 
 	return (rc);
 }
 
-/* ARGSUSED */
 static int
 t4_cb_open(dev_t *devp, int flag, int otyp, cred_t *credp)
 {
 	struct adapter *sc;
 
-	if (otyp != OTYP_CHR)
+	if (otyp != OTYP_CHR) {
 		return (EINVAL);
+	}
 
 	sc = ddi_get_soft_state(t4_soft_state, getminor(*devp));
-	if (sc == NULL)
+	if (sc == NULL) {
 		return (ENXIO);
+	}
 
 	return (atomic_cas_uint(&sc->open, 0, EBUSY));
 }
 
-/* ARGSUSED */
 static int
 t4_cb_close(dev_t dev, int flag, int otyp, cred_t *credp)
 {
-	struct adapter *sc;
+	struct adapter *sc = ddi_get_soft_state(t4_soft_state, getminor(dev));
 
-	sc = ddi_get_soft_state(t4_soft_state, getminor(dev));
-	if (sc == NULL)
+	if (sc == NULL) {
 		return (EINVAL);
+	}
 
 	(void) atomic_swap_uint(&sc->open, 0);
 	return (0);
 }
 
-/* ARGSUSED */
 static int
 t4_cb_ioctl(dev_t dev, int cmd, intptr_t d, int mode, cred_t *credp, int *rp)
 {
-	int instance;
-	struct adapter *sc;
-	void *data = (void *)d;
-
-	if (crgetuid(credp) != 0)
+	if (crgetuid(credp) != 0) {
 		return (EPERM);
+	}
 
-	instance = getminor(dev);
-	sc = ddi_get_soft_state(t4_soft_state, instance);
-	if (sc == NULL)
+	struct adapter *sc = ddi_get_soft_state(t4_soft_state, getminor(dev));
+
+	if (sc == NULL) {
 		return (EINVAL);
+	}
 
-	return (t4_ioctl(sc, cmd, data, mode));
+	return (t4_ioctl(sc, cmd, (void *)d, mode));
 }
 
-static unsigned int
-getpf(struct adapter *sc)
+static uint_t
+t4_getpf(struct adapter *sc)
 {
-	int rc, *data;
-	uint_t n, pf;
+	int *data;
+	uint_t n;
 
-	rc = ddi_prop_lookup_int_array(DDI_DEV_T_ANY, sc->dip,
+	const int rc = ddi_prop_lookup_int_array(DDI_DEV_T_ANY, sc->dip,
 	    DDI_PROP_DONTPASS, "reg", &data, &n);
 	if (rc != DDI_SUCCESS) {
-		cxgb_printf(sc->dip, CE_WARN,
-		    "failed to lookup \"reg\" property: %d", rc);
-		return (0xff);
+		return (UINT_MAX);
 	}
 
-	pf = PCI_REG_FUNC_G(data[0]);
+	const uint_t pf = PCI_REG_FUNC_G(data[0]);
 	ddi_prop_free(data);
 
 	return (pf);
@@ -942,21 +1343,12 @@ getpf(struct adapter *sc)
  * become the master, and reset the device.
  */
 static int
-prep_firmware(struct adapter *sc)
+t4_prep_firmware(struct adapter *sc)
 {
 	int rc;
-	size_t fw_size;
-	int reset = 1;
-	enum dev_state state;
-	unsigned char *fw_data;
-	struct fw_hdr *card_fw, *hdr;
-	const char *fw_file = NULL;
-	firmware_handle_t fw_hdl;
-	struct fw_info fi, *fw_info = &fi;
-
-	struct driver_properties *p = &sc->props;
 
 	/* Contact firmware, request master */
+	enum dev_state state;
 	rc = t4_fw_hello(sc, sc->mbox, sc->mbox, MASTER_MUST, &state);
 	if (rc < 0) {
 		rc = -rc;
@@ -969,8 +1361,9 @@ prep_firmware(struct adapter *sc)
 		sc->flags |= TAF_MASTER_PF;
 
 	/* We may need FW version info for later reporting */
-	t4_get_version_info(sc);
+	(void) t4_get_version_info(sc);
 
+	const char *fw_file = NULL;
 	switch (CHELSIO_CHIP_VERSION(sc->params.chip)) {
 	case CHELSIO_T4:
 		fw_file = "t4fw.bin";
@@ -986,58 +1379,58 @@ prep_firmware(struct adapter *sc)
 		return (EINVAL);
 	}
 
+	firmware_handle_t fw_hdl;
 	if (firmware_open(T4_PORT_NAME, fw_file, &fw_hdl) != 0) {
 		cxgb_printf(sc->dip, CE_WARN, "Could not open %s\n", fw_file);
 		return (EINVAL);
 	}
 
-	fw_size = firmware_get_size(fw_hdl);
-
+	const size_t fw_size = firmware_get_size(fw_hdl);
 	if (fw_size < sizeof (struct fw_hdr)) {
-		cxgb_printf(sc->dip, CE_WARN, "%s is too small (%ld bytes)\n",
+		cxgb_printf(sc->dip, CE_WARN, "%s is too small (%lu bytes)\n",
 		    fw_file, fw_size);
-		firmware_close(fw_hdl);
+		(void) firmware_close(fw_hdl);
 		return (EINVAL);
 	}
-
 	if (fw_size > FLASH_FW_MAX_SIZE) {
 		cxgb_printf(sc->dip, CE_WARN,
-		    "%s is too large (%ld bytes, max allowed is %ld)\n",
+		    "%s is too large (%lu bytes, max allowed is %lu)\n",
 		    fw_file, fw_size, FLASH_FW_MAX_SIZE);
-		firmware_close(fw_hdl);
+		(void) firmware_close(fw_hdl);
 		return (EFBIG);
 	}
 
-	fw_data = kmem_zalloc(fw_size, KM_SLEEP);
+	unsigned char *fw_data = kmem_zalloc(fw_size, KM_SLEEP);
 	if (firmware_read(fw_hdl, 0, fw_data, fw_size) != 0) {
 		cxgb_printf(sc->dip, CE_WARN, "Failed to read from %s\n",
 		    fw_file);
-		firmware_close(fw_hdl);
+		(void) firmware_close(fw_hdl);
 		kmem_free(fw_data, fw_size);
 		return (EINVAL);
 	}
-	firmware_close(fw_hdl);
-
-	bzero(fw_info, sizeof (*fw_info));
-	fw_info->chip = CHELSIO_CHIP_VERSION(sc->params.chip);
-
-	hdr = (struct fw_hdr *)fw_data;
-	fw_info->fw_hdr.fw_ver = hdr->fw_ver;
-	fw_info->fw_hdr.chip = hdr->chip;
-	fw_info->fw_hdr.intfver_nic = hdr->intfver_nic;
-	fw_info->fw_hdr.intfver_vnic = hdr->intfver_vnic;
-	fw_info->fw_hdr.intfver_ofld = hdr->intfver_ofld;
-	fw_info->fw_hdr.intfver_ri = hdr->intfver_ri;
-	fw_info->fw_hdr.intfver_iscsipdu = hdr->intfver_iscsipdu;
-	fw_info->fw_hdr.intfver_iscsi = hdr->intfver_iscsi;
-	fw_info->fw_hdr.intfver_fcoepdu = hdr->intfver_fcoepdu;
-	fw_info->fw_hdr.intfver_fcoe = hdr->intfver_fcoe;
+	(void) firmware_close(fw_hdl);
+
+	const struct fw_hdr *hdr = (struct fw_hdr *)fw_data;
+	struct fw_info fi;
+	bzero(&fi, sizeof (fi));
+	fi.chip				= CHELSIO_CHIP_VERSION(sc->params.chip);
+	fi.fw_hdr.fw_ver		= hdr->fw_ver;
+	fi.fw_hdr.chip			= hdr->chip;
+	fi.fw_hdr.intfver_nic		= hdr->intfver_nic;
+	fi.fw_hdr.intfver_vnic		= hdr->intfver_vnic;
+	fi.fw_hdr.intfver_ofld		= hdr->intfver_ofld;
+	fi.fw_hdr.intfver_ri		= hdr->intfver_ri;
+	fi.fw_hdr.intfver_iscsipdu	= hdr->intfver_iscsipdu;
+	fi.fw_hdr.intfver_iscsi		= hdr->intfver_iscsi;
+	fi.fw_hdr.intfver_fcoepdu	= hdr->intfver_fcoepdu;
+	fi.fw_hdr.intfver_fcoe		= hdr->intfver_fcoe;
 
 	/* allocate memory to read the header of the firmware on the card */
-	card_fw = kmem_zalloc(sizeof (*card_fw), KM_SLEEP);
+	struct fw_hdr *card_fw = kmem_zalloc(sizeof (struct fw_hdr), KM_SLEEP);
 
-	rc = -t4_prep_fw(sc, fw_info, fw_data, fw_size, card_fw,
-	    p->t4_fw_install, state, &reset);
+	int reset = 1;
+	rc = -t4_prep_fw(sc, &fi, fw_data, fw_size, card_fw,
+	    sc->props.t4_fw_install, state, &reset);
 
 	kmem_free(card_fw, sizeof (*card_fw));
 	kmem_free(fw_data, fw_size);
@@ -1065,18 +1458,21 @@ prep_firmware(struct adapter *sc)
 	if (sc->flags & TAF_MASTER_PF) {
 		/* Handle default vs special T4 config file */
 
-		rc = partition_resources(sc);
-		if (rc != 0)
-			goto err;	/* error message displayed already */
+		rc = t4_partition_resources(sc);
+		if (rc != 0) {
+			return (rc);
+		}
 	}
 
 	sc->flags |= FW_OK;
 	return (0);
-err:
-	return (rc);
-
 }
 
+struct memwin {
+	uint32_t base;
+	uint32_t aperture;
+};
+
 static const struct memwin t4_memwin[] = {
 	{ MEMWIN0_BASE, MEMWIN0_APERTURE },
 	{ MEMWIN1_BASE, MEMWIN1_APERTURE },
@@ -1101,8 +1497,8 @@ static const struct memwin t5_memwin[] = {
  * valid and lies entirely within the memtype specified.  The global address of
  * the start of the range is returned in addr.
  */
-int
-validate_mt_off_len(struct adapter *sc, int mtype, uint32_t off, int len,
+static int
+t4_validate_mt_off_len(struct adapter *sc, int mtype, uint32_t off, int len,
     uint32_t *addr)
 {
 	uint32_t em, addr_len, maddr, mlen;
@@ -1156,7 +1552,7 @@ validate_mt_off_len(struct adapter *sc, int mtype, uint32_t off, int len,
 }
 
 static void
-memwin_info(struct adapter *sc, int win, uint32_t *base, uint32_t *aperture)
+t4_memwin_info(struct adapter *sc, int win, uint32_t *base, uint32_t *aperture)
 {
 	const struct memwin *mw;
 
@@ -1176,7 +1572,7 @@ memwin_info(struct adapter *sc, int win, uint32_t *base, uint32_t *aperture)
  * Upload configuration file to card's memory.
  */
 static int
-upload_config_file(struct adapter *sc, uint32_t *mt, uint32_t *ma)
+t4_upload_config_file(struct adapter *sc, uint32_t *mt, uint32_t *ma)
 {
 	int rc = 0;
 	size_t cflen, cfbaselen;
@@ -1231,17 +1627,17 @@ upload_config_file(struct adapter *sc, uint32_t *mt, uint32_t *ma)
 		cxgb_printf(sc->dip, CE_WARN,
 		    "config file too long (%d, max allowed is %d).  ",
 		    cflen, FLASH_CFG_MAX_SIZE);
-		firmware_close(fw_hdl);
+		(void) firmware_close(fw_hdl);
 		return (EFBIG);
 	}
 
-	rc = validate_mt_off_len(sc, mtype, maddr, cflen, &addr);
+	rc = t4_validate_mt_off_len(sc, mtype, maddr, cflen, &addr);
 	if (rc != 0) {
 		cxgb_printf(sc->dip, CE_WARN,
 		    "%s: addr (%d/0x%x) or len %d is not valid: %d.  "
 		    "Will try to use the config on the card, if any.\n",
 		    __func__, mtype, maddr, cflen, rc);
-		firmware_close(fw_hdl);
+		(void) firmware_close(fw_hdl);
 		return (EFAULT);
 	}
 
@@ -1250,13 +1646,13 @@ upload_config_file(struct adapter *sc, uint32_t *mt, uint32_t *ma)
 	if (firmware_read(fw_hdl, 0, cfdata, cflen) != 0) {
 		cxgb_printf(sc->dip, CE_WARN, "Failed to read from %s\n",
 		    cfg_file);
-		firmware_close(fw_hdl);
+		(void) firmware_close(fw_hdl);
 		kmem_free(cfbase, cfbaselen);
 		return (EINVAL);
 	}
-	firmware_close(fw_hdl);
+	(void) firmware_close(fw_hdl);
 
-	memwin_info(sc, 2, &mw_base, &mw_aperture);
+	t4_memwin_info(sc, 2, &mw_base, &mw_aperture);
 	while (cflen) {
 		off = t4_position_memwin(sc, 2, addr);
 		n = min(cflen, mw_aperture - off);
@@ -1277,24 +1673,26 @@ upload_config_file(struct adapter *sc, uint32_t *mt, uint32_t *ma)
  * the firmware to process it.
  */
 static int
-partition_resources(struct adapter *sc)
+t4_partition_resources(struct adapter *sc)
 {
 	int rc;
-	struct fw_caps_config_cmd caps;
-	uint32_t mtype, maddr, finicsum, cfcsum;
+	uint32_t mtype, maddr;
 
-	rc = upload_config_file(sc, &mtype, &maddr);
+	rc = t4_upload_config_file(sc, &mtype, &maddr);
 	if (rc != 0) {
 		mtype = FW_MEMTYPE_CF_FLASH;
 		maddr = t4_flash_cfg_addr(sc);
 	}
 
+	struct fw_caps_config_cmd caps;
 	bzero(&caps, sizeof (caps));
 	caps.op_to_write = BE_32(V_FW_CMD_OP(FW_CAPS_CONFIG_CMD) |
 	    F_FW_CMD_REQUEST | F_FW_CMD_READ);
 	caps.cfvalid_to_len16 = BE_32(F_FW_CAPS_CONFIG_CMD_CFVALID |
 	    V_FW_CAPS_CONFIG_CMD_MEMTYPE_CF(mtype) |
-	    V_FW_CAPS_CONFIG_CMD_MEMADDR64K_CF(maddr >> 16) | FW_LEN16(caps));
+	    V_FW_CAPS_CONFIG_CMD_MEMADDR64K_CF(maddr >> 16) |
+	    FW_LEN16(struct fw_caps_config_cmd));
+
 	rc = -t4_wr_mbox(sc, sc->mbox, &caps, sizeof (caps), &caps);
 	if (rc != 0) {
 		cxgb_printf(sc->dip, CE_WARN,
@@ -1302,26 +1700,26 @@ partition_resources(struct adapter *sc)
 		return (rc);
 	}
 
-	finicsum = ntohl(caps.finicsum);
-	cfcsum = ntohl(caps.cfcsum);
-	if (finicsum != cfcsum) {
+	if (caps.finicsum != caps.cfcsum) {
 		cxgb_printf(sc->dip, CE_WARN,
 		    "WARNING: config file checksum mismatch: %08x %08x\n",
-		    finicsum, cfcsum);
+		    caps.finicsum, caps.cfcsum);
 	}
-	sc->cfcsum = cfcsum;
+	sc->cfcsum = caps.cfcsum;
 
-	/* TODO: Need to configure this correctly */
-	caps.toecaps = htons(FW_CAPS_CONFIG_TOE);
+	/* Disable unused offloads and features */
+	caps.toecaps = 0;
 	caps.iscsicaps = 0;
 	caps.rdmacaps = 0;
 	caps.fcoecaps = 0;
+	caps.cryptocaps = 0;
+
 	/* TODO: Disable VNIC cap for now */
-	caps.niccaps ^= htons(FW_CAPS_CONFIG_NIC_VM);
+	caps.niccaps &= BE_16(~FW_CAPS_CONFIG_NIC_VM);
 
-	caps.op_to_write = htonl(V_FW_CMD_OP(FW_CAPS_CONFIG_CMD) |
+	caps.op_to_write = BE_32(V_FW_CMD_OP(FW_CAPS_CONFIG_CMD) |
 	    F_FW_CMD_REQUEST | F_FW_CMD_WRITE);
-	caps.cfvalid_to_len16 = htonl(FW_LEN16(caps));
+	caps.cfvalid_to_len16 = BE_32(FW_LEN16(caps));
 	rc = -t4_wr_mbox(sc, sc->mbox, &caps, sizeof (caps), NULL);
 	if (rc != 0) {
 		cxgb_printf(sc->dip, CE_WARN,
@@ -1342,7 +1740,7 @@ partition_resources(struct adapter *sc)
  * Configuration Files and hard-coded initialization ...
  */
 static int
-adap__pre_init_tweaks(struct adapter *sc)
+t4_init_adap_tweaks(struct adapter *sc)
 {
 	int rx_dma_offset = 2; /* Offset of RX packets into DMA buffers */
 
@@ -1364,12 +1762,10 @@ adap__pre_init_tweaks(struct adapter *sc)
  * t4_sge_init and t4_fw_initialize.
  */
 static int
-get_params__pre_init(struct adapter *sc)
+t4_init_get_params_pre(struct adapter *sc)
 {
 	int rc;
 	uint32_t param[2], val[2];
-	struct fw_devlog_cmd cmd;
-	struct devlog_params *dlog = &sc->params.devlog;
 
 	/*
 	 * Grab the raw VPD parameters.
@@ -1401,25 +1797,31 @@ get_params__pre_init(struct adapter *sc)
 		sc->params.nports++;
 		val[0] &= val[0] - 1;
 	}
-
 	sc->params.vpd.cclk = val[1];
 
 	/* Read device log parameters. */
+	struct fw_devlog_cmd cmd;
 	bzero(&cmd, sizeof (cmd));
-	cmd.op_to_write = htonl(V_FW_CMD_OP(FW_DEVLOG_CMD) |
+	cmd.op_to_write = BE_32(V_FW_CMD_OP(FW_DEVLOG_CMD) |
 	    F_FW_CMD_REQUEST | F_FW_CMD_READ);
-	cmd.retval_len16 = htonl(FW_LEN16(cmd));
+	cmd.retval_len16 = BE_32(FW_LEN16(struct fw_devlog_cmd));
+
 	rc = -t4_wr_mbox(sc, sc->mbox, &cmd, sizeof (cmd), &cmd);
 	if (rc != 0) {
 		cxgb_printf(sc->dip, CE_WARN,
 		    "failed to get devlog parameters: %d.\n", rc);
-		bzero(dlog, sizeof (*dlog));
-		rc = 0;	/* devlog isn't critical for device operation */
+
+		/* devlog isn't critical for device operation */
+		bzero(&sc->params.devlog, sizeof (sc->params.devlog));
+		rc = 0;
 	} else {
-		val[0] = ntohl(cmd.memtype_devlog_memaddr16_devlog);
-		dlog->memtype = G_FW_DEVLOG_CMD_MEMTYPE_DEVLOG(val[0]);
-		dlog->start = G_FW_DEVLOG_CMD_MEMADDR16_DEVLOG(val[0]) << 4;
-		dlog->size = ntohl(cmd.memsize_devlog);
+		const uint32_t info =
+		    BE_32(cmd.memtype_devlog_memaddr16_devlog);
+		struct devlog_params *dlog = &sc->params.devlog;
+
+		dlog->memtype = G_FW_DEVLOG_CMD_MEMTYPE_DEVLOG(info);
+		dlog->start = G_FW_DEVLOG_CMD_MEMADDR16_DEVLOG(info) << 4;
+		dlog->size = BE_32(cmd.memsize_devlog);
 	}
 
 	return (rc);
@@ -1430,11 +1832,10 @@ get_params__pre_init(struct adapter *sc)
  * has been initialized by the firmware at this point.
  */
 static int
-get_params__post_init(struct adapter *sc)
+t4_init_get_params_post(struct adapter *sc)
 {
 	int rc;
 	uint32_t param[4], val[4];
-	struct fw_caps_config_cmd caps;
 
 	param[0] = FW_PARAM_PFVF(IQFLINT_START);
 	param[1] = FW_PARAM_PFVF(EQ_START);
@@ -1447,27 +1848,10 @@ get_params__post_init(struct adapter *sc)
 		return (rc);
 	}
 
-	sc->sge.iq_start = val[0];
-	sc->sge.eq_start = val[1];
-	sc->sge.iqmap_sz = val[2] - sc->sge.iq_start + 1;
-	sc->sge.eqmap_sz = val[3] - sc->sge.eq_start + 1;
-
-	uint32_t r = t4_read_reg(sc, A_SGE_EGRESS_QUEUES_PER_PAGE_PF);
-	r >>= S_QUEUESPERPAGEPF0 +
-	    (S_QUEUESPERPAGEPF1 - S_QUEUESPERPAGEPF0) * sc->pf;
-	sc->sge.s_qpp = r & M_QUEUESPERPAGEPF0;
-
-	/* get capabilites */
-	bzero(&caps, sizeof (caps));
-	caps.op_to_write = htonl(V_FW_CMD_OP(FW_CAPS_CONFIG_CMD) |
-	    F_FW_CMD_REQUEST | F_FW_CMD_READ);
-	caps.cfvalid_to_len16 = htonl(FW_LEN16(caps));
-	rc = -t4_wr_mbox(sc, sc->mbox, &caps, sizeof (caps), &caps);
-	if (rc != 0) {
-		cxgb_printf(sc->dip, CE_WARN,
-		    "failed to get card capabilities: %d.\n", rc);
-		return (rc);
-	}
+	sc->sge.iqmap_start = val[0];
+	sc->sge.eqmap_start = val[1];
+	sc->sge.iqmap_sz = (val[2] - sc->sge.iqmap_start) + 1;
+	sc->sge.eqmap_sz = (val[3] - sc->sge.eqmap_start) + 1;
 
 	/* Check if DBQ timer is available for tracking egress completions */
 	param[0] = (V_FW_PARAMS_MNEM(FW_PARAMS_MNEM_DEV) |
@@ -1479,6 +1863,19 @@ get_params__post_init(struct adapter *sc)
 		    ARRAY_SIZE(sc->sge.dbq_timers), sc->sge.dbq_timers);
 		if (rc == 0) {
 			sc->flags |= TAF_DBQ_TIMER;
+
+			/*
+			 * Expose DBQ timer values as property, converting them
+			 * to plain `int` as required.
+			 */
+			int tmp_encode[ARRAY_SIZE(sc->sge.dbq_timers)];
+			for (uint_t i = 0; i < ARRAY_SIZE(sc->sge.dbq_timers);
+			    i++) {
+				tmp_encode[i] = sc->sge.dbq_timers[i];
+			};
+			(void) ddi_prop_update_int_array(sc->dev, sc->dip,
+			    "tx-reclaim-timer-us-values",
+			    tmp_encode, SGE_NTIMERS);
 		} else {
 			sc->sge.dbq_timer_tick = 0;
 		}
@@ -1533,7 +1930,7 @@ get_params__post_init(struct adapter *sc)
 }
 
 static int
-set_params__post_init(struct adapter *sc)
+t4_init_set_params(struct adapter *sc)
 {
 	uint32_t param, val;
 
@@ -1643,15 +2040,34 @@ prop_lookup_int(struct adapter *sc, char *name, int defval)
 	    name, defval));
 }
 
+static bool
+prop_lookup_bool(struct adapter *sc, char *name, bool defval)
+{
+	int rc;
+
+	rc = ddi_prop_get_int(sc->dev, sc->dip, DDI_PROP_DONTPASS, name, -1);
+	if (rc == -1) {
+		rc = ddi_prop_get_int(DDI_DEV_T_ANY, sc->dip, DDI_PROP_DONTPASS,
+		    name, -1);
+	}
+
+	if (rc != -1) {
+		return (rc != 0);
+	} else {
+		return (defval);
+	}
+}
+
 const uint_t t4_holdoff_timer_default[SGE_NTIMERS] = {5, 10, 20, 50, 100, 200};
 const uint_t t4_holdoff_pktcnt_default[SGE_NCOUNTERS] = {1, 8, 16, 32};
 
-static int
-init_driver_props(struct adapter *sc, struct driver_properties *p)
+static void
+t4_init_driver_props(struct adapter *sc)
 {
+	struct driver_properties *p = &sc->props;
 	dev_t dev = sc->dev;
 	dev_info_t *dip = sc->dip;
-	int i;
+	int val;
 
 	/*
 	 * For now, just use the defaults for the hold-off timers and counters.
